/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.users.model.tables


import cc.cinnamon.canary.users.model.Keys
import cc.cinnamon.canary.users.model.Public
import org.jooq.*
import org.jooq.impl.TableImpl

import javax.annotation.Generated
import java.util.Arrays


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:56:50.783Z", comments = "This class is generated by jOOQ")
class UsersRoles private constructor(alias: String, aliased: Table<Record>, parameters: Array<Field<*>>? = null) : TableImpl<Record>(alias, null, aliased, parameters, "") {

    /**
     * The class holding records for this type
     */
    override fun getRecordType(): Class<Record> {
        return Record::class.java
    }

    /**
     * The column `public.users_roles.id`.
     */
    val ID = AbstractTable.createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('users_roles_id_seq'::regclass)", org.jooq.impl.SQLDataType.BIGINT)), this, "")

    /**
     * The column `public.users_roles.user_id`.
     */
    val USER_ID = AbstractTable.createField("user_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "")

    /**
     * The column `public.users_roles.role_id`.
     */
    val ROLE_ID = AbstractTable.createField("role_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "")

    /**
     * Create a `public.users_roles` table reference
     */
    constructor() : this("users_roles", null) {
    }

    /**
     * Create an aliased `public.users_roles` table reference
     */
    constructor(alias: String) : this(alias, USERS_ROLES) {
    }

    /**
     * {@inheritDoc}
     */
    override fun getSchema(): Schema {
        return Public.PUBLIC
    }

    /**
     * {@inheritDoc}
     */
    override fun getIdentity(): Identity<Record, Long> {
        return Keys.IDENTITY_USERS_ROLES
    }

    /**
     * {@inheritDoc}
     */
    override fun getPrimaryKey(): UniqueKey<Record> {
        return Keys.USERS_ROLES_PKEY
    }

    /**
     * {@inheritDoc}
     */
    override fun getKeys(): List<UniqueKey<Record>> {
        return Arrays.asList(Keys.USERS_ROLES_PKEY)
    }

    /**
     * {@inheritDoc}
     */
    override fun getReferences(): List<ForeignKey<Record, *>> {
        return Arrays.asList<ForeignKey<Record, *>>(Keys.USERS_ROLES__USERS_ROLES_USER_ID_FKEY, Keys.USERS_ROLES__USERS_ROLES_ROLE_ID_FKEY)
    }

    /**
     * {@inheritDoc}
     */
    override fun `as`(alias: String): UsersRoles {
        return UsersRoles(alias, this)
    }

    /**
     * Rename this table
     */
    override fun rename(name: String): UsersRoles {
        return UsersRoles(name, null)
    }

    companion object {

        private val serialVersionUID: Long = -475631613

        /**
         * The reference instance of `public.users_roles`
         */
        val USERS_ROLES = UsersRoles()
    }
}
